<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (18)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="the-switch-statement">The “switch” statement</h1>
    <p>
      A <code>switch</code> statement can replace multiple
      <code>if</code> checks.
    </p>
    <p>
      It gives a more descriptive way to compare a value with multiple variants.
    </p>
    <h2 id="the-syntax">The syntax</h2>
    <p>
      The <code>switch</code> has one or more <code>case</code> blocks and an
      optional default.
    </p>
    <p>It looks like this:</p>
    <p>
      ```js no-beautify switch(x) { case ‘value1’: // if (x === ‘value1’) …
      [break]
    </p>
    <p>case ‘value2’: // if (x === ‘value2’) … [break]</p>
    <p>default: … [break] } ```</p>
    <ul>
      <li>
        The value of <code>x</code> is checked for a strict equality to the
        value from the first <code>case</code> (that is, <code>value1</code>)
        then to the second (<code>value2</code>) and so on.
      </li>
      <li>
        If the equality is found, <code>switch</code> starts to execute the code
        starting from the corresponding <code>case</code>, until the nearest
        <code>break</code> (or until the end of <code>switch</code>).
      </li>
      <li>
        If no case is matched then the <code>default</code> code is executed (if
        it exists).
      </li>
    </ul>
    <h2 id="an-example">An example</h2>
    <p>An example of <code>switch</code> (the executed code is highlighted):</p>
    <p>```js run let a = 2 + 2;</p>
    <p>
      switch (a) { case 3: alert( ‘Too small’ ); break; <em>!</em> case 4:
      alert( ‘Exactly!’ ); break; <em>/!</em> case 5: alert( ‘Too big’ ); break;
      default: alert( “I don’t know such values” ); } ```
    </p>
    <p>
      Here the <code>switch</code> starts to compare <code>a</code> from the
      first <code>case</code> variant that is <code>3</code>. The match fails.
    </p>
    <p>
      Then <code>4</code>. That’s a match, so the execution starts from
      <code>case 4</code> until the nearest <code>break</code>.
    </p>
    <p>
      <strong
        >If there is no <code>break</code> then the execution continues with the
        next <code>case</code> without any checks.</strong
      >
    </p>
    <p>An example without <code>break</code>:</p>
    <p>```js run let a = 2 + 2;</p>
    <p>
      switch (a) { case 3: alert( ‘Too small’ ); <em>!</em> case 4: alert(
      ‘Exactly!’ ); case 5: alert( ‘Too big’ ); default: alert( “I don’t know
      such values” ); <em>/!</em> } ```
    </p>
    <p>
      In the example above we’ll see sequential execution of three
      <code>alert</code>s:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="at">alert</span>(<span class="st">&quot;Exactly!&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="at">alert</span>(<span class="st">&quot;Too big&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="at">alert</span>(<span class="st">&quot;I don&#39;t know such values&quot;</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      ```<code>smart header="Any expression can be a</code>switch/case<code
        >argument" Both</code
      >switch<code>and</code>case` allow arbitrary expressions.
    </p>
    <p>For example:</p>
    <p>```js run let a = “1”; let b = 0;</p>
    <p>
      switch (+a) { <em>!</em> case b + 1: alert(“this runs, because +a is 1,
      exactly equals b+1”); break; <em>/!</em>
    </p>
    <p>default: alert(“this doesn’t run”); }</p>
    <pre><code>
Here `+a` gives `1`, that&#39;s compared with `b + 1` in `case`, and the corresponding code is executed.
</code></pre>
    <h2 id="grouping-of-case">Grouping of “case”</h2>
    <p>
      Several variants of <code>case</code> which share the same code can be
      grouped.
    </p>
    <p>
      For example, if we want the same code to run for <code>case 3</code> and
      <code>case 5</code>:
    </p>
    <p>```js run no-beautify let a = 3;</p>
    <p>switch (a) { case 4: alert(‘Right!’); break;</p>
    <p>
      <em>!</em> case 3: // (<em
        >) grouped two cases case 5: alert(‘Wrong!’); alert(“Why don’t you take
        a math class?”); break; </em
      >/!*
    </p>
    <p>default: alert(‘The result is strange. Really.’); } ```</p>
    <p>Now both <code>3</code> and <code>5</code> show the same message.</p>
    <p>
      The ability to “group” cases is a side-effect of how
      <code>switch/case</code> works without <code>break</code>. Here the
      execution of <code>case 3</code> starts from the line <code>(*)</code> and
      goes through <code>case 5</code>, because there’s no <code>break</code>.
    </p>
    <h2 id="type-matters">Type matters</h2>
    <p>
      Let’s emphasize that the equality check is always strict. The values must
      be of the same type to match.
    </p>
    <p>For example, let’s consider the code:</p>
    <p>
      ```js run let arg = prompt(“Enter a value?”); switch (arg) { case ‘0’:
      case ‘1’: alert( ‘One or zero’ ); break;
    </p>
    <p>case ‘2’: alert( ‘Two’ ); break;</p>
    <p>
      case 3: alert( ‘Never executes!’ ); break; default: alert( ‘An unknown
      value’ ); }
    </p>
    <pre><code>
1. For `0`, `1`, the first `alert` runs.
2. For `2` the second `alert` runs.
3. But for `3`, the result of the `prompt` is a string `&quot;3&quot;`, which is not strictly equal `===` to the number `3`. So we&#39;ve got a dead code in `case 3`! The `default` variant will execute.</code></pre>
  </body>
</html>
